C     (C) 2008 D. V. Wiebe
C
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     This file is part of the GetData project.
C
C     This program is free software; you can redistribute it and/or
C     modify it under the terms of the GNU General Public License as
C     published by the Free Software Foundation; either version 2 of the
C     License, or (at your option) any later version.
C
C     GetData is distributed in the hope that it will be useful, but
C     WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
C     General Public License for more details.
C
C     You should have received a copy of the GNU General Public License
C     along with GetData; if not, write to the Free Software Foundation,
C     Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
C

C     Fortran 77 parameters for getdata.  This file defines handy
C     constants useful to Fortran programs

      
C     Error codes
C     Corresponding to GD_E_OK
      INTEGER GD_EOK
      PARAMETER (GD_EOK=0)
C     Corresponding to GD_E_OPEN
      INTEGER GD_EOP
      PARAMETER (GD_EOP=1)
C     Corresponding to GD_E_FORMAT
      INTEGER GD_EFO
      PARAMETER (GD_EFO=2)
C     Corresponding to GD_E_TRUNC
      INTEGER GD_ETR
      PARAMETER (GD_ETR=3)
C     Corresponding to GD_E_CREAT
      INTEGER GD_ECR
      PARAMETER (GD_ECR=4)
C     Corresponding to GD_E_BAD_CODE
      INTEGER GD_EBC
      PARAMETER (GD_EBC=5)
C     Corresponding to GD_E_BAD_TYPE
      INTEGER GD_EBT
      PARAMETER (GD_EBT=6)
C     Corresponding to GD_E_RAW_IO
      INTEGER GD_ERW
      PARAMETER (GD_ERW=7)
C     Corresponding to GD_E_OPEN_INCLUDE
      INTEGER GD_EOI
      PARAMETER (GD_EOI=8)
C     Corresponding to GD_E_INTERNAL_ERROR
      INTEGER GD_EIE
      PARAMETER (GD_EIE=9)
C     Corresponding to GD_E_ALLOC
      INTEGER GD_EAL
      PARAMETER (GD_EAL=10)
C     Corresponding to GD_E_RANGE
      INTEGER GD_ERA
      PARAMETER (GD_ERA=11)
C     Corresponding to GD_E_OPEN_LINFILE
      INTEGER GD_EOL
      PARAMETER (GD_EOL=12)
C     Corresponding to GD_E_RECURSE_LEVEL
      INTEGER GD_ERL
      PARAMETER (GD_ERL=13)
C     Corresponding to GD_E_BAD_DIRFILE
      INTEGER GD_EBD
      PARAMETER (GD_EBD=14)
C     Corresponding to GD_E_BAD_FIELD_TYPE
      INTEGER GD_EBF
      PARAMETER (GD_EBF=15)
C     Corresponding to GD_E_ACCMODE
      INTEGER GD_EAC
      PARAMETER (GD_EAC=16)
C     Corresponding to GD_E_UNSUPPORTED
      INTEGER GD_UNS
      PARAMETER (GD_UNS=17)
C     Corresponding to GD_E_BAD_ENTRY
      INTEGER GD_EBE
      PARAMETER (GD_EBE=19)
C     Corresponding to GD_E_DUPLICATE
      INTEGER GD_EDU
      PARAMETER (GD_EDU=20)
C     Corresponding to GD_E_DIMENSION
      INTEGER GD_EDM
      PARAMETER (GD_EDM=21)
C     Corresponding to GD_E_BAD_INDEX
      INTEGER GD_EBI
      PARAMETER (GD_EBI=22)
C     Corresponding to GD_E_BAD_SCALAR
      INTEGER GD_EBS
      PARAMETER (GD_EBS=23)
C     Corresponding to GD_E_BAD_REFERENCE
      INTEGER GD_EBR
      PARAMETER (GD_EBR=24)
C     Corresponding to GD_E_PROTECTED
      INTEGER GD_EPT
      PARAMETER (GD_EPT=25)

C Open flags
C     Corresponding to GD_RDONLY
      INTEGER GD_RO
      PARAMETER (GD_RO=0)
C     Corresponding to GD_RDWR
      INTEGER GD_RW
      PARAMETER (GD_RW=1)
C     Corresponding to GD_CREAT
      INTEGER GD_CR
      PARAMETER (GD_CR=16)
C     Corresponding to GD_EXCL
      INTEGER GD_EX
      PARAMETER (GD_EX=32)
C     Corresponding to GD_TRUNC
      INTEGER GD_TR
      PARAMETER (GD_TR=64)
C     Corresponding to GD_BIG_ENDIAN
      INTEGER GD_BE
      PARAMETER (GD_BE=4)
C     Corresponding to GD_LITTLE_ENDIAN
      INTEGER GD_LE
      PARAMETER (GD_LE=8)
C     Corresponding to GD_FORCE_ENCODDED
      INTEGER GD_FC
      PARAMETER (GD_FC=2)
C     Corresponding to GD_FORCE_ENDIAN
      INTEGER GD_FE
      PARAMETER (GD_FE=256)
C     Corresponding to GD_PEDANTIC
      INTEGER GD_PE
      PARAMETER (GD_PE=128)
C     Corresponding to GD_AUTO_ENCODED
      INTEGER GD_EA
      PARAMETER (GD_EA=0)
C     Corresponding to GD_UNENCODED
      INTEGER GD_EN
      PARAMETER (GD_EN=4096)
C     Corresponding to GD_TEXT_ENCODED
      INTEGER GD_ET
      PARAMETER (GD_ET=8192)
C     Corresponding to GD_SLIM_ENCODED
      INTEGER GD_ES
      PARAMETER (GD_ES=12288)

C Field types
C     Corresponding to GD_NO_ENTRY
      INTEGER GD_NOE
      PARAMETER (GD_NOE=0)
C     Corresponding to GD_RAW_ENTRY
      INTEGER GD_RWE
      PARAMETER (GD_RWE=1)
C     Corresponding to GD_LINCOM_ENTRY
      INTEGER GD_LCE
      PARAMETER (GD_LCE=2)
C     Corresponding to GD_LINTERP_ENTRY
      INTEGER GD_LTE
      PARAMETER (GD_LTE=3)
C     Corresponding to GD_BIT_ENTRY
      INTEGER GD_BTE
      PARAMETER (GD_BTE=4)
C     Corresponding to GD_MULTIPLY_ENTRY
      INTEGER GD_MTE
      PARAMETER (GD_MTE=5)
C     Corresponding to GD_PHASE_ENTRY
      INTEGER GD_PHE
      PARAMETER (GD_PHE=6)
C     Corresponding to GD_INDEX_ENTRY
      INTEGER GD_IXE
      PARAMETER (GD_IXE=7)
C     Corresponding to GD_CONST_ENTRY
      INTEGER GD_COE
      PARAMETER (GD_COE=257)
C     Corresponding to GD_STRING_ENTRY
      INTEGER GD_STE
      PARAMETER (GD_STE=258)

C Data types -- the unsigned types won't work when passed as
C               a return type, but we keep them anyways, since
C               they might appear as a result of calling GDFERW
C     Corresponding to GD_NULL
      INTEGER GD_NUL
      PARAMETER (GD_NUL=0)
C     Corresponding to GD_UINT8
      INTEGER GD_U8
      PARAMETER (GD_U8=1)
C     Corresponding to GD_INT8
      INTEGER GD_I8
      PARAMETER (GD_I8=17)
C     Corresponding to GD_UINT16
      INTEGER GD_U16
      PARAMETER (GD_U16=2)
C     Corresponding to GD_INT16
      INTEGER GD_I16
      PARAMETER (GD_I16=18)
C     Corresponding to GD_UINT32
      INTEGER GD_U32
      PARAMETER (GD_U32=4)
C     Corresponding to GD_INT32
      INTEGER GD_I32
      PARAMETER (GD_I32=20)
C     Corresponding to GD_UINT64
      INTEGER GD_U64
      PARAMETER (GD_U64=8)
C     Corresponding to GD_INT64
      INTEGER GD_I64
      PARAMETER (GD_I64=24)
C     Corresponding to GD_FLOAT32
      INTEGER GD_F32
      PARAMETER (GD_F32=36)
C     Corresponding to GD_FLOAT64
      INTEGER GD_F64
      PARAMETER (GD_F64=40)


C Externals
C     Corresponding to dirfile_add_bit(3)
      EXTERNAL GDFABT
C     Corresponding to dirfile_add_const(3)
      EXTERNAL GDFACO
C     Corresponding to dirfile_add_lincom(3)
      EXTERNAL GDFALC
C     Corresponding to dirfile_add_linterp(3)
      EXTERNAL GDFALT
C     Corresponding to dirfile_add_multiply(3)
      EXTERNAL GDFAMT
C     Corresponding to dirfile_add_phase(3)
      EXTERNAL GDFAPH
C     Corresponding to dirfile_add_raw(3)
      EXTERNAL GDFARW
C     Corresponding to dirfile_add_spec(3)
      EXTERNAL GDFASP
C     Corresponding to dirfile_add_string(3)
      EXTERNAL GDFAST
C     Corresponding to dirfile_close(3)
      EXTERNAL GDFCLS
C     Corresponding to get_entry(3) for BIT fields
      EXTERNAL GDFEBT
C     Corresponding to get_entry(3) for CONST fields
      EXTERNAL GDFECO
C     Corresponding to get_entry(3) for LINCOM fields
      EXTERNAL GDFELC
C     Corresponding to get_entry(3) for LINTERP fields
      EXTERNAL GDFELT
C     Corresponding to get_entry(3) for MULTIPLY fields
      EXTERNAL GDFEMT
C     Corresponding to get_entry(3) for PHASE fields
      EXTERNAL GDFEPH
C     Returns the dirfile->error member
      EXTERNAL GDFERR
C     Corresponding to get_entry(3) for RAW fields
      EXTERNAL GDFERW
C     Corresponding to get_field_list(3) (sort of)
      EXTERNAL GDFFDN
C     Returns the field type
      EXTERNAL GDFFDT
C     Get the fragment index for a field
      EXTERNAL GDFFGI
C     Corresponding to get_fragmentname(3)
      EXTERNAL GDFFGN
C     Corresponding to dirfile_flush(3)
      EXTERNAL GDFFLS
C     Corresponding to get_field_list_by_type(3) (sort of)
      EXTERNAL GDFFNT
C     Returns the maximum field name length
      EXTERNAL GDFFNX
C     Corresponding to get_constant(3)
      EXTERNAL GDFGCO
C     Corresponding to getdata(3)
      EXTERNAL GDFGET
C     Corresponding to get_string(3)
      EXTERNAL GDFGST
C     Corresponding to dirfile_include(3)
      EXTERNAL GDFINC
C     Corresponding to dirfile_madd_bit(3)
      EXTERNAL GDFMBT
C     Corresponding to dirfile_madd_const(3)
      EXTERNAL GDFMCO
C     Corresponding to dirfile_metaflush(3)
      EXTERNAL GDFMFL
C     Corresponding to get_metafield_list(3) (sort of)
      EXTERNAL GDFMFN
C     Corresponding to get_metafield_list_by_type(3) (sort of)
      EXTERNAL GDFMFT
C     Returns the maximum field name length for a meta field list
      EXTERNAL GDFMFX
C     Corresponding to dirfile_madd_lincom(3)
      EXTERNAL GDFMLC
C     Corresponding to dirfile_madd_linterp(3)
      EXTERNAL GDFMLT
C     Corresponding to dirfile_madd_multiply(3)
      EXTERNAL GDFMMT
C     Corresponding to dirfile_madd_phase(3)
      EXTERNAL GDFMPH
C     Corresponding to dirfile_madd_spec(3)
      EXTERNAL GDFMSP
C     Corresponding to dirfile_madd_string(3)
      EXTERNAL GDFMST
C     Corresponding to get_metavector_list(3) (sort of)
      EXTERNAL GDFMVN
C     Corresponding to get_nfields(3)
      EXTERNAL GDFNFD
C     Corresponding to get_nfragments(3)
      EXTERNAL GDFNFG
C     Corresponding to get_nframes(3)
      EXTERNAL GDFNFR
C     Corresponding to get_nfields_by_type(3)
      EXTERNAL GDFNFT
C     Corresponding to get_nmetafields(3)
      EXTERNAL GDFNMF
C     Corresponding to get_nmetafields_by_type(3)
      EXTERNAL GDFNMT
C     Corresponding to get_nmetavectors(3)
      EXTERNAL GDFNMV
C     Corresponding to get_nvectors(3)
      EXTERNAL GDFNVE
C     Corresponding to dirfile_open(3)
      EXTERNAL GDFOPN
C     Corresponding to put_constant(3)
      EXTERNAL GDFPCO
C     Corresponding to put_string(3)
      EXTERNAL GDFPST
C     Corresponding to putdata(3)
      EXTERNAL GDFPUT
C     Corresponding to get_spf(3)
      EXTERNAL GDFSPF
C     Corresponding to get_error_string(3)
      EXTERNAL GDFSTR
C     Corresponding to get_vector_list(3) (sort of)
      EXTERNAL GDFVEN
